# # -*- coding: utf-8 -*-
# from setuphelpers import *
# import json

# def update_package():
#     # Declaring local variables
#     package_updated = False
#     proxies = get_proxies()
#     if not proxies:
#         proxies = get_proxies_from_wapt_console()
#     app_name = control.name
#     api_url = "https://sourceforge.net/projects/freeplane/best_release.json"
#     # Getting latest version information from official sources
#     print("API used is: %s" % api_url)
#     json_load = json.loads(wgets(api_url, proxies=proxies))
#     for download in json_load["platform_releases"]:
#         latest_bin = json_load["platform_releases"][download]["filename"].split("/")[-1]
#         if ".zip" in latest_bin:
#             download_url = json_load["platform_releases"][download]["url"].rsplit("/", 1)[0] + "/" + latest_bin
#             version = latest_bin.split("-")[1].split(".zip")[0]
#             break
#     # Downloading latest binaries
#     print("Latest %s version is: %s" % (app_name, version))
#     print("Download URL is: %s" % download_url)
#     if not isfile(latest_bin):
#         print("Downloading: %s" % latest_bin)
#         wget(download_url, latest_bin,connect_timeout=30, proxies=proxies)
#     else:
#         print("Binary is present: %s" % latest_bin)
#     control.set_software_version(version)
#     control.save_control_to_wapt()
#     # Deleting outdated binaries
#     remove_outdated_binaries(latest_bin)
#     # Validating update-package-sources
#     return package_updated



# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()
    update_dict = {
        "bin_contains": {
            "debian_based-all": "all.deb",
        },
    }
    url = r"https://sourceforge.net/projects/freeplane/files/freeplane stable/"

    api_url = "https://sourceforge.net/projects/freeplane/best_release.json"
    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = json.loads(wgets(api_url, proxies=proxies))
    version = json_load["release"]["filename"].split("-")[1].split(".zip")[0]


    # Getting latest version from official sources
    download_url = rf"https://sourceforge.net/projects/freeplane/files/freeplane stable/freeplane_{version}~upstream-1_all.deb/download"
    latest_bin = download_url.split("/")[-2]


    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)
    # arch_list = ensure_list(control.architecture)
    # remove_outdated_binaries(version, filename_contains=("x64" if "x64" in arch_list else "x86" if "x86" in arch_list else []))

    # Checking version from file
    if get_os_name() == "Windows" and "windows" in control.target_os.lower():
        version_from_file = get_version_from_binary(latest_bin)
        if Version(version_from_file, 4) == Version(version, 4):
            print(f"INFO: Binary file version ({version_from_file}) corresponds to online version ({version})")
        else:
            error(f"ERROR: Binary file version ({version_from_file}) do NOT corresponds to online version ({version})")

    # Changing version of the package
    if Version(version, 4) > Version(control.get_software_version(), 4):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated

    # # Changing version of the package and validating update-package-sources
    # return complete_control_version(control, version)


